]> arthur.barton.de Git - netdata.git/blob - plugins.d/charts.d.plugin
Merge pull request #528 from paulfantom/master
[netdata.git] / plugins.d / charts.d.plugin
1 #!/bin/bash
2
3 PROGRAM_FILE="$0"
4 PROGRAM_NAME="$(basename $0)"
5 PROGRAM_NAME="${PROGRAM_NAME/.plugin}"
6
7 # if you need to run parallel charts.d processes
8 # just link this files with a different name
9 # in the same directory, with a .plugin suffix
10 # netdata will start multiple of them
11 # each will have a different config file
12
13 echo >&2 "$PROGRAM_NAME: started from '$PROGRAM_FILE' with options: $*"
14
15 if [ $(( ${BASH_VERSINFO[0]} )) -lt 4 ]
16 then
17         echo >&2
18         echo >&2 "$PROGRAM_NAME: ERROR"
19         echo >&2 "BASH version 4 or later is required."
20         echo >&2 "You are running version: ${BASH_VERSION}"
21         echo >&2 "Please upgrade."
22         echo >&2
23         exit 1
24 fi
25
26 # check a few commands
27 require_cmd() {
28         which "$1" >/dev/null
29         if [ $? -ne 0 ]
30                 then
31                 echo >&2 "$PROGRAM_NAME: ERROR: Command '$1' is not found in the system path."
32                 return 1
33         fi
34         return 0
35 }
36
37 require_cmd date || exit 1
38 require_cmd sed || exit 1
39 require_cmd basename || exit 1
40 require_cmd dirname || exit 1
41 require_cmd cat || exit 1
42 require_cmd grep || exit 1
43 require_cmd egrep || exit 1
44 require_cmd mktemp || exit 1
45 require_cmd awk || exit 1
46
47 # -----------------------------------------------------------------------------
48 # insternal defaults
49 # netdata exposes a few environment variables for us
50
51 pause_method="sleep" # use either "suspend" or "sleep"
52                      # DO NOT USE SUSPEND - LINUX WILL SUSPEND NETDATA TOO
53                      # THE WHOLE PROCESS GROUP - NOT JUST THE SHELL
54
55 pluginsd="${NETDATA_PLUGINS_DIR}"
56 [ -z "$pluginsd" ] && pluginsd="$( dirname $PROGRAM_FILE )"
57
58 confd="${NETDATA_CONFIG_DIR-/etc/netdata}"
59 chartsd="$pluginsd/../charts.d"
60
61 myconfig="$confd/$PROGRAM_NAME.conf"
62
63 minimum_update_frequency="${NETDATA_UPDATE_EVERY-1}"
64 update_every=${minimum_update_frequency}        # this will be overwritten by the command line
65
66 # work around for non BASH shells
67 charts_create="_create"
68 charts_update="_update"
69 charts_check="_check"
70 charts_undescore="_"
71
72 # when making iterations, charts.d can loop more frequently
73 # to prevent plugins missing iterations.
74 # this is a percentage relative to update_every to align its
75 # iterations.
76 # The minimum is 10%, the maximum 100%.
77 # So, if update_every is 1 second and time_divisor is 50,
78 # charts.d will iterate every 500ms.
79 # Charts will be called to collect data only if the time
80 # passed since the last time the collected data is equal or
81 # above their update_every.
82 time_divisor=50
83
84 # number of seconds to run without restart
85 # after this time, charts.d.plugin will exit
86 # netdata will restart it
87 restart_timeout=$((3600 * 4))
88
89 # check if the charts.d plugins are using global variables
90 # they should not.
91 # It does not currently support BASH v4 arrays, so it is
92 # disabled
93 dryrunner=0
94
95 # check for timeout command
96 check_for_timeout=1
97
98 # the default enable/disable value for all charts
99 enable_all_charts="yes"
100
101 # -----------------------------------------------------------------------------
102 # parse parameters
103
104 debug=0
105 check=0
106 chart_only=
107 while [ ! -z "$1" ]
108 do
109         if [ "$1" = "check" ]
110         then
111                 check=1
112                 shift
113                 continue
114         fi
115
116         if [ "$1" = "debug" -o "$1" = "all" ]
117         then
118                 debug=1
119                 shift
120                 continue
121         fi
122
123         if [ -f "$chartsd/$1.chart.sh" ]
124         then
125                 debug=1
126                 chart_only="$( echo $1.chart.sh | sed "s/\.chart\.sh$//g" )"
127                 shift
128                 continue
129         fi
130
131         if [ -f "$chartsd/$1" ]
132         then
133                 debug=1
134                 chart_only="$( echo $1 | sed "s/\.chart\.sh$//g" )"
135                 shift
136                 continue
137         fi
138
139         # number check
140         n="$1"
141         x=$(( n ))
142         if [ "$x" = "$n" ]
143         then
144                 shift
145                 update_every=$x
146                 [ $update_every -lt $minimum_update_frequency ] && update_every=$minimum_update_frequency
147                 continue
148         fi
149
150         echo >&2 "Cannot understand parameter $1. Aborting."
151         echo "DISABLE"
152         exit 1
153 done
154
155
156 # -----------------------------------------------------------------------------
157 # load my configuration
158
159 if [ -f "$myconfig" ]
160         then
161         . "$myconfig"
162         if [ $? -ne 0 ]
163         then
164                 echo >&2 "$PROGRAM_NAME: cannot load $myconfig"
165                 echo "DISABLE"
166                 exit 1
167         fi
168         time_divisor=$((time_divisor))
169         [ $time_divisor -lt 10 ] && time_divisor=10
170         [ $time_divisor -gt 100 ] && time_divisor=100
171 else
172         echo >&2 "$PROGRAM_NAME: configuration file '$myconfig' not found. Using defaults."
173 fi
174
175 if [ "$pause_method" = "suspend" ]
176 then
177         # enable bash job control
178         # this is required for suspend to work
179         set -m
180 fi
181
182 # we check for the timeout command, after we load our
183 # configuration, so that the user may overwrite the
184 # timeout command we use, providing a function that
185 # can emulate the timeout command we need:
186 # > timeout SECONDS command ...
187 if [ $check_for_timeout -eq 1 ]
188         then
189         require_cmd timeout || exit 1
190 fi
191
192 # -----------------------------------------------------------------------------
193 # internal checks
194
195 # netdata passes the requested update frequency as the first argument
196 update_every=$(( update_every + 1 - 1)) # makes sure it is a number
197 test $update_every -eq 0 && update_every=1 # if it is zero, make it 1
198
199 # check the charts.d directory
200 if [ ! -d "$chartsd" ]
201         then
202         echo >&2 "$PROGRAM_NAME: cannot find charts directory '$chartsd'"
203         echo "DISABLE"
204 fi
205
206
207 # -----------------------------------------------------------------------------
208 # loop control
209
210 # default sleep function
211 LOOPSLEEPMS_HIGHRES=0
212 loopsleepms() {
213         [ "$1" = "tellwork" ] && shift
214         sleep $1
215 }
216
217 now_ms=
218 current_time_ms() {
219         now_ms="$(date +'%s')000"
220 }
221
222 # if found and included, this file overwrites loopsleepms()
223 # and current_time_ms() with a high resolution timer function
224 # for precise looping.
225 . "$pluginsd/loopsleepms.sh.inc"
226
227
228 # -----------------------------------------------------------------------------
229 # library functions
230
231 fixid() {
232         echo "$*" |\
233                 tr -c "[A-Z][a-z][0-9]" "_" |\
234                 sed -e "s|^_\+||g" -e "s|_\+$||g" -e "s|_\+|_|g" |\
235                 tr "[A-Z]" "[a-z]"
236 }
237
238 # convert any floating point number
239 # to integer, give a multiplier
240 # the result is stored in ${FLOAT2INT_RESULT}
241 # so that no fork is necessary
242 # the multiplier must be a power of 10
243 float2int() {
244         local f m="$2" a b l v=($1)
245         f=${v[0]}
246
247         # echo >&2 "value='${1}' f='${f}', m='${m}'"
248
249         # the length of the multiplier - 1
250         l=$(( ${#m} - 1 ))
251
252         # check if the number is in scientific notation
253         if [[ ${f} =~ ^[[:space:]]*(-)?[0-9.]+(e|E)(\+|-)[0-9]+ ]]
254                 then
255                 # convert it to decimal
256                 # unfortunately, this fork cannot be avoided
257                 # if you know of a way to avoid it, please let me know
258                 f=$(printf "%0.${l}f" ${f})
259         fi
260
261         # split the floating point number
262         # in integer (a) and decimal (b)
263         a=${f/.*/}
264         b=${f/*./}
265
266         # if the integer part is missing
267         # set it to zero
268         [ -z "${a}" ] && a="0"
269
270         # strip leading zeros from the integer part
271         # base 10 convertion
272         a=$((10#$a))
273
274         # check the length of the decimal part
275         # against the length of the multiplier
276         if [ ${#b} -gt ${l} ]
277                 then
278                 # too many digits - take the most significant
279                 b=${b:0:${l}}
280
281         elif [ ${#b} -lt ${l} ]
282                 then
283                 # too few digits - pad with zero on the right
284                 local z="00000000000000000000000" r=$((l - ${#b}))
285                 b="${b}${z:0:${r}}"
286         fi
287
288         # strip leading zeros from the decimal part
289         # base 10 convertion
290         b=$((10#$b))
291
292         # store the result
293         FLOAT2INT_RESULT=$(( (a * m) + b ))
294         #echo >&2 "FLOAT2INT_RESULT='${FLOAT2INT_RESULT}'"
295 }
296
297
298 # -----------------------------------------------------------------------------
299 # charts check functions
300
301 all_charts() {
302         cd "$chartsd"
303         [ $? -ne 0 ] && echo >&2 "$PROGRAM_NAME: Cannot cd to $chartsd" && return 1
304
305         ls *.chart.sh | sed "s/\.chart\.sh$//g"
306 }
307
308 all_enabled_charts() {
309         local charts= enabled=
310
311         # find all enabled charts
312
313         for chart in $( all_charts )
314         do
315                 eval "enabled=\$$chart"
316                 if [ -z "${enabled}" ]
317                         then
318                         enabled="${enable_all_charts}"
319                 fi
320
321                 if [ ! "${enabled}" = "yes" ]
322                 then
323                         echo >&2 "$PROGRAM_NAME: '$chart' is NOT enabled. Add a line with $chart=yes in $myconfig to enable it (or remove the line that disables it)."
324                 else
325                         [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: '$chart' is enabled."
326                         local charts="$charts $chart"
327                 fi
328         done
329
330         local charts2=
331         for chart in $charts
332         do
333                 # check the enabled charts
334                 local check="$( cat "$chartsd/$chart.chart.sh" | sed "s/^ \+//g" | grep "^$chart$charts_check()" )"
335                 if [ -z "$check" ]
336                 then
337                         echo >&2 "$PROGRAM_NAME: chart '$chart' does not seem to have a $chart$charts_check() function. Disabling it."
338                         continue
339                 fi
340
341                 local create="$( cat "$chartsd/$chart.chart.sh" | sed "s/^ \+//g" | grep "^$chart$charts_create()" )"
342                 if [ -z "$create" ]
343                 then
344                         echo >&2 "$PROGRAM_NAME: chart '$chart' does not seem to have a $chart$charts_create() function. Disabling it."
345                         continue
346                 fi
347
348                 local update="$( cat "$chartsd/$chart.chart.sh" | sed "s/^ \+//g" | grep "^$chart$charts_update()" )"
349                 if [ -z "$update" ]
350                 then
351                         echo >&2 "$PROGRAM_NAME: chart '$chart' does not seem to have a $chart$charts_update() function. Disabling it."
352                         continue
353                 fi
354
355                 # check its config
356                 #if [ -f "$confd/$chart.conf" ]
357                 #then
358                 #       if [ ! -z "$( cat "$confd/$chart.conf" | sed "s/^ \+//g" | grep -v "^$" | grep -v "^#" | grep -v "^$chart$charts_undescore" )" ]
359                 #       then
360                 #               echo >&2 "$PROGRAM_NAME: chart's $chart config $confd/$chart.conf should only have lines starting with $chart$charts_undescore . Disabling it."
361                 #               continue
362                 #       fi
363                 #fi
364
365                 #if [ $dryrunner -eq 1 ]
366                 #       then
367                 #       "$pluginsd/charts.d.dryrun-helper.sh" "$chart" "$chartsd/$chart.chart.sh" "$confd/$chart.conf" >/dev/null
368                 #       if [ $? -ne 0 ]
369                 #       then
370                 #               echo >&2 "$PROGRAM_NAME: chart's $chart did not pass the dry run check. This means it uses global variables not starting with $chart. Disabling it."
371                 #               continue
372                 #       fi
373                 #fi
374
375                 local charts2="$charts2 $chart"
376         done
377
378         echo $charts2
379         [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: enabled charts: $charts2"
380 }
381
382
383 # -----------------------------------------------------------------------------
384 # load the charts
385
386 suffix_update_every="_update_every"
387 active_charts=
388 for chart in $( all_enabled_charts )
389 do
390         [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: loading chart: '$chartsd/$chart.chart.sh'"
391         . "$chartsd/$chart.chart.sh"
392
393         if [ -f "$confd/$chart.conf" ]
394         then
395                 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: loading chart options: '$confd/$chart.conf'"
396                 . "$confd/$chart.conf"
397         else
398                 echo >&2 "$PROGRAM_NAME: $chart: configuration file '$confd/$chart.conf' not found. Using defaults."
399         fi
400
401         eval "dt=\$$chart$suffix_update_every"
402         dt=$(( dt + 1 - 1 )) # make sure it is a number
403         if [ $dt -lt $update_every ]
404         then
405                 eval "$chart$suffix_update_every=$update_every"
406         fi
407
408         $chart$charts_check
409         if [ $? -eq 0 ]
410         then
411                 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: '$chart' activated"
412                 active_charts="$active_charts $chart"
413         else
414                 echo >&2 "$PROGRAM_NAME: chart '$chart' check() function reports failure."
415         fi
416 done
417 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: activated charts: $active_charts"
418
419
420 # -----------------------------------------------------------------------------
421 # check overwrites
422
423 # enable work time reporting
424 debug_time=
425 test $debug -eq 1 && debug_time=tellwork
426
427 # if we only need a specific chart, remove all the others
428 if [ ! -z "${chart_only}" ]
429 then
430         [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: requested to run only for: '${chart_only}'"
431         check_charts=
432         for chart in $active_charts
433         do
434                 if [ "$chart" = "$chart_only" ]
435                 then
436                         check_charts="$chart"
437                         break
438                 fi
439         done
440         active_charts="$check_charts"
441 fi
442 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: activated charts: $active_charts"
443
444 # stop if we just need a pre-check
445 if [ $check -eq 1 ]
446 then
447         echo >&2 "CHECK RESULT"
448         echo >&2 "Will run the charts: $active_charts"
449         exit 0
450 fi
451
452 # -----------------------------------------------------------------------------
453 # create temp dir
454
455 TMP_DIR=
456 chartsd_cleanup() {
457         cd /tmp
458         if [ ! -z "$TMP_DIR" -a -d "$TMP_DIR" ]
459         then
460                 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: cleaning up temporary directory $TMP_DIR ..."
461                 rm -rf "$TMP_DIR"
462         fi
463         exit 0
464 }
465 trap chartsd_cleanup EXIT
466 trap chartsd_cleanup SIGHUP
467 trap chartsd_cleanup INT
468
469 if [ $UID = "0" ]
470 then
471         TMP_DIR="$( mktemp -d /var/run/netdata-${PROGRAM_NAME}-XXXXXXXXXX )"
472 else
473         TMP_DIR="$( mktemp -d /tmp/.netdata-${PROGRAM_NAME}-XXXXXXXXXX )"
474 fi
475
476 cd "$TMP_DIR" || exit 1
477
478 # -----------------------------------------------------------------------------
479 # create charts
480
481 run_charts=
482 for chart in $active_charts
483 do
484         [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: Calling '$chart$charts_create()'..."
485         $chart$charts_create
486         if [ $? -eq 0 ]
487         then
488                 run_charts="$run_charts $chart"
489                 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: '$chart' has initialized."
490         else
491                 echo >&2 "$PROGRAM_NAME: chart '$chart' function '$chart$charts_create()' reports failure."
492         fi
493 done
494 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: run_charts='$run_charts'"
495
496
497 # -----------------------------------------------------------------------------
498 # update dimensions
499
500 if [ -z "$run_charts" ]
501         then
502         echo >&2 "$PROGRAM_NAME: No charts to collect data from."
503         echo "DISABLE"
504         exit 1
505 fi
506
507 declare -A charts_last_update=() charts_update_every=() charts_next_update=() charts_run_counter=() charts_serial_failures=()
508 global_update() {
509         local exit_at \
510                 c=0 dt ret last_ms exec_start_ms exec_end_ms \
511                 chart now_charts=() next_charts=($run_charts) \
512                 next_ms x seconds millis
513
514         # return the current time in ms in $now_ms
515         current_time_ms
516
517         exit_at=$(( now_ms + (restart_timeout * 1000) ))
518
519         for chart in $run_charts
520         do
521                 eval "charts_update_every[$chart]=\$$chart$suffix_update_every"
522                 test -z "${charts_update_every[$chart]}" && charts_update_every[$charts]=$update_every
523                 charts_last_update[$chart]=$((now_ms - (now_ms % (charts_update_every[$chart] * 1000) ) ))
524                 charts_next_update[$chart]=$(( charts_last_update[$chart] + (charts_update_every[$chart] * 1000) ))
525                 charts_run_counter[$chart]=0
526                 charts_serial_failures[$chart]=0
527
528                 echo "CHART netdata.plugin_chartsd_$chart '' 'Execution time for $chart plugin' 'milliseconds / run' charts.d netdata.plugin_charts area 145000 ${charts_update_every[$chart]}"
529                 echo "DIMENSION run_time 'run time' absolute 1 1"
530         done
531
532         # the main loop
533         while [ "${#next_charts[@]}" -gt 0 ]
534         do
535                 c=$((c + 1))
536                 now_charts=("${next_charts[@]}")
537                 next_charts=()
538
539                 # return the current time in ms in $now_ms
540                 current_time_ms
541
542                 for chart in "${now_charts[@]}"
543                 do
544                         # echo >&2 "DEBUG: chart: $chart last: ${charts_last_update[$chart]}, next: ${charts_next_update[$chart]}, now: ${now_ms}"
545                         if [ ${now_ms} -ge ${charts_next_update[$chart]} ]
546                         then
547                                 last_ms=${charts_last_update[$chart]}
548                                 dt=$(( (now_ms - last_ms) ))
549                                 # echo >&2 "DEBUG: chart: $chart last: ${charts_last_update[$chart]}, next: ${charts_next_update[$chart]}, now: ${now_ms}, dt: ${dt}"
550
551                                 charts_last_update[$chart]=${now_ms}
552
553                                 while [ ${charts_next_update[$chart]} -lt ${now_ms} ]
554                                 do
555                                         charts_next_update[$chart]=$(( charts_next_update[$chart] + (charts_update_every[$chart] * 1000) ))
556                                 done
557
558                                 # the first call should not give a duration
559                                 # so that netdata calibrates to current time
560                                 dt=$(( dt * 1000 ))
561                                 charts_run_counter[$chart]=$(( charts_run_counter[$chart] + 1 ))
562                                 if [ ${charts_run_counter[$chart]} -eq 1 ]
563                                         then
564                                         dt=
565                                 fi
566
567                                 exec_start_ms=$now_ms
568                                 $chart$charts_update $dt
569                                 ret=$?
570                                 
571                                 # return the current time in ms in $now_ms
572                                 current_time_ms; exec_end_ms=$now_ms
573
574                                 echo "BEGIN netdata.plugin_chartsd_$chart $dt"
575                                 echo "SET run_time = $(( exec_end_ms - exec_start_ms ))"
576                                 echo "END"
577
578                                 if [ $ret -eq 0 ]
579                                 then
580                                         charts_serial_failures[$chart]=0
581                                         next_charts+=($chart)
582                                 else
583                                         charts_serial_failures[$chart]=$(( charts_serial_failures[$chart] + 1 ))
584
585                                         if [ charts_serial_failures[$chart] -gt 10 ]
586                                                 then
587                                                 echo >&2 "$PROGRAM_NAME: chart '$chart' update() function reported failure ${charts_serial_failures[$chart]} times. Disabling it."
588                                         else
589                                                 echo >&2 "$PROGRAM_NAME: chart '$chart' update() function reports failure. Will keep trying for a while."
590                                                 next_charts+=($chart)
591                                         fi
592                                 fi
593                         else
594                                 next_charts+=($chart)
595                         fi
596                 done
597
598                 if [ "$pause_method" = "suspend" ]
599                 then
600                         echo "STOPPING_WAKE_ME_UP_PLEASE"
601                         suspend || ( echo >&2 "$PROGRAM_NAME: suspend returned error $?, falling back to sleep."; loopsleepms $debug_time $update_every $time_divisor)
602                 else
603                         # wait the time you are required to
604                         next_ms=$((now_ms + (update_every * 1000 * 100) ))
605                         for x in "${charts_next_update[@]}"; do [ ${x} -lt ${next_ms} ] && next_ms=${x}; done
606                         next_ms=$((next_ms - now_ms))
607
608                         if [ ${LOOPSLEEPMS_HIGHRES} -eq 1 -a ${next_ms} -gt 0 ]
609                                 then
610                                 seconds=$(( next_ms / 1000 ))
611                                 millis=$(( next_ms % 1000 ))
612                                 [ ${millis} -lt 10  ] && millis="0${millis}"
613                                 [ ${millis} -lt 100 ] && millis="0${millis}"
614                                 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: sleeping for ${seconds}.${millis} seconds."
615                                 sleep ${seconds}.${millis}
616                         else
617                                 sleep $update_every
618                         fi
619                 fi
620
621                 test ${now_ms} -ge ${exit_at} && exit 0
622         done
623
624         echo >&2 "$PROGRAM_NAME: Nothing left to do. Disabling charts.d.plugin."
625         echo "DISABLE"
626 }
627
628 global_update